#include <string.h>
#include <stdlib.h>

#include "util.h"
#include "dic.h"
#include "mem.h"

void MenuCargaDicFic (char **ppsDic, int *pnPal, int max)
{
	FILE *pfic;

	if (!ppsDic)
	{
		printf("Error en MenuCargaDicFic: ppsDic a NULL\n");
		exit(1);
	}

	pfic=LeerNomFic("r");
	if (pfic)
	{
		/* BorraDic(ppsDic,pnPal); */
		*pnPal+=CargaDicFic(pnPal,pfic,ppsDic,max);
		fclose(pfic);
	}
}

/*--------------------------------------------------------------------*/

void MenuSalvaDic(char **ppsDic,int nPal)
{
	FILE *pfic;

	if (!ppsDic)
	{
		printf("Error en MenuSalvaDic: ppsDic a NULL\n");
		exit(1);
	}

	if (!nPal)
		printf("\n\tDiccionario vacio\n");
	else
	{
		pfic=LeerNomFic("w");
		if (pfic)
		{
			SalvaDic(pfic,ppsDic,nPal);
			fclose(pfic);
		}
	}
}

/*--------------------------------------------------------------------*/

void BorraDic(char **ppsDic,int *pnPal)
{
	int i;

	if (!ppsDic)
	{
		printf("Error en BorraPal: ppsDic a NULL\n");
		exit(1);
	}
	for (i=0;i<*pnPal;i++)
	{
		ppsDic[i]=pcMemFree(ppsDic[i]);
	}
	*pnPal=0;
}

/*--------------------------------------------------------------------*/

int CargaDicFic(int *pnPal,FILE *pfic,char **ppsDic,int max)
{
	char s[MAXENT];
	int i=0;

	if (!ppsDic)
	{
		printf("Error en CargaDic: ppsDic a NULL\n");
		exit(1);
	}

	while(fscanf(pfic,"%s",s)!=EOF)
	{
		if (i>=max)
		{
			printf("\n\tError en LeerDicFic: diccionario mayor que %d\n\n",max);
			break;
		}
		ppsDic[*pnPal+i]=pcMemCrea(strlen(s)+1);
		strcpy(ppsDic[*pnPal+i],s);
		i++;
	}

	return i;
}

/*--------------------------------------------------------------------*/

void OrdenaDic(char **ppsDic,int nPal)
{
    int med,i,j;
    char *ptemp;

    for (med=nPal/2;med>0;med/=2)
        for (i=med;i<nPal;i++)
            for (j=i-med;j>=0&&(strcmp(ppsDic[j],ppsDic[j+med])>0);j-=med){
                ptemp=ppsDic[j];
                ppsDic[j]=ppsDic[med+j];
                ppsDic[med+j]=ptemp;
            }
}

/*--------------------------------------------------------------------*/

void ImpDic(char **ppsDic,int nPal)
{
	int i;

	if (!ppsDic)
	{
		printf("Error en ImpDic: ppsDic a NULL\n");
		exit(1);
	}

	if (!nPal)
		printf("\n\n\tDiccionario vacio\n");
	else
	{
		for (i=0;i<nPal;i++)
			puts(ppsDic[i]);
	}
}

/*--------------------------------------------------------------------*/

void SalvaDic(FILE *pfic,char **ppsDic, int nPal)
{
	int i;

	if (!ppsDic)
	{
		printf("Error en SalvaDic: ppsDic a NULL\n");
		exit(1);
	}

	if (!nPal)
		printf("\n\tDiccionario vacio\n");
	else
	{
		for (i=0;i<nPal;i++)
			if (ppsDic[i])
				fprintf(pfic,"%s\n",ppsDic[i]);
	}
}

/*--------------------------------------------------------------------*/

void MenuBorraPal(char **ppsDic,int *pnPal)
{
    int pos;

    if (!ppsDic)
    {
        printf("Error en MenuBorraPal: ppsDic a NULL\n");exit(1);
    }
    if (!*pnPal)
       printf("\n\tDiccionario vacio\n");
    else if ((pos=BuscaPal(ppsDic,*pnPal))!=*pnPal)
         AjustaDic (ppsDic,pos,pnPal);       /* reajusta diccionario */
    else
        printf("Palabra no encontrada");
}

/*--------------------------------------------------------------------*/

int BuscaPal (char **ppsDic,int nPal)
{
    char pal[MAXENT];
    int pos,i;
    pos=nPal;

    printf("Introduzca la palabra: ");
    gets(pal);

    for (i=0;i<nPal;i++)
        if (!strcmp(pal,ppsDic[i]))
           pos=i;
    return pos;
}

/*--------------------------------------------------------------------*/

void AjustaDic (char **ppsDic,int pos,int *pnPal)
{
    int i,j;
    char **aux;
    char temp[MAXENT];

    i=pos;

    for (j=0;j<*pnPal;j++)
        if (j>=pos)
        {
            strcpy(temp,ppsDic[j+1]);
            ppsDic[i]=pcMemFree(ppsDic[j]); /* libera y pone a NULL */
            ppsDic[i]=pcMemCrea(strlen(temp)+1);
            strcpy(ppsDic[i],temp);
            i++;
        }
    *pnPal-=1;
}

/*--------------------------------------------------------------------*/

void MenuBorraRep(char **ppsDic,int *pnPal)
{
    int i;

    OrdenaDic (ppsDic,*pnPal);  /* ordena el diccionario */
    for (i=0;i<(*pnPal-1);i++)
        if (!strcmp(ppsDic[i],ppsDic[i+1]))   /* si son iguales */
        {
            AjustaDic (ppsDic,i+1,pnPal);
        }
}