#include <stdlib.h>
#include <stdio.h>

#include "mem.h"

static int npc;
static int nppv;


/*----------------------------------------------------------------------*/
void IniMem() {
	npc=0;
	nppv=0;
}



/*----------------------------------------------------------------------*/
void ActMem() {
	printf("\nControl de memoria dinmica:\n");
	printf("npc= %d\n",npc);
	printf("nppv=%d\n",nppv);
}


/*----------------------------------------------------------------------*/
char *pcMemCrea(int n) {
	char *pc=NULL;

	if ((n<=0) || ((pc= (char *) calloc(n,sizeof(char)))==NULL)) {
		printf("Error en pcMemCrea: puntero %x elementos %d" ,pc,n);
		exit(1);
	}
	npc++;
	return pc;
}


/*----------------------------------------------------------------------*/
char* pcMemFree(char *pc) {
	if (pc) {
		free(pc);
		npc--;
	} else {
		printf("Error en pcMemFree: puntero a NULL\n");
		exit(1);
	}
	return NULL;
}


/*----------------------------------------------------------------------*/
void** ppvMemCrea(int n) {
	void **ppv;
	int i;

	if ((n<=0) || ((ppv=(void **) calloc(n,sizeof(void *)))==NULL)) {
		printf("Error en ppvMemCrea: puntero %x elementos %d",ppv,n);
		exit(1);
	}

	for(i=0;i<n;i++)
		ppv[i]=NULL;
	nppv++;

	return ppv;
}


/*----------------------------------------------------------------------*/
void** ppvMemFree(void **ppv) {
	if (ppv) {
		free(ppv);
		nppv--;
	} else {
		printf("error en ppvMemFree: puntero a NULL\n");
		exit(1);
	}

	return NULL;
}


