/*************************************************************************
	Prototipos biblioteca mem.h: GESTION DE MEMORIA DINAMICA

	Descripcion: Agrupa las funciones de reserva y liberacin de
				memoria dinamica para los tipos bsicos.. Cada tipo
				basico lleva sociado una variable y dos funciones
				Por ejemplo para tipo char se tiene:
				int npc: se incrementa cada vez que se reserva
						memoria, y se decrementa cada vez que
						se libera.
				char *pcMemCrea(int n)
						Reserva n int y devuelve la
						direccin a partir d e la cual est
						reservada la memoria.
						Si no hay memoria, o n no es mayor que 0
						o *ppi no es nulo, aborta la ejecucin
						del programa
						Incrementa npc
						Conviene asegurarse que el puntero donde
						se recoge la direccin tiene valor NULL
						es decir, que no apunta a otra zona de
						memoria reservada
				char *pcMemFree(int *pc)
						Libera el puntero y devuelve NULL
						Decrementa la variables esttica npc
						El vevolver NULL permite inicializar el
						puntero liberado adecuadamente para ser
						reutilizado en otra reserva
						pc debe ser distinto de NULL para
						asegurar que liberamos memoria
						reservada

				Para depurar si todo lo que se ha reservado se
				ha liberado se sumnistan dos funciones ms:
					void MemIni(void)
						Se coloca al inicio del program
						principal o de la subrutina a depurar.
						Inicializa cada variables esttica
						asociada a cada tipo a 0
					void MemAct(void)
						Imprime por pantalla el estado de cada
						variable esttica asociada a cada tipo
						Si todo ha ido bien el resultado es 0
						Si una variable es distinta de 0,
						indica memoria sin liberar(>0) o memoria
						que se intentando liberar ms de una vez(<0)
						Se debe colocar al final del programa o
						despus del programa a depurar
*************************************************************************/


#ifndef mem_h
#define mem_h

#define MAXENT 100

void IniMem(void);
void ActMem(void);

char* pcMemCrea(int n);
char* pcMemFree(char *pc);
void** ppvMemCrea(int n);
void** ppvMemFree(void **ppv);

#endif